use grammers_client::{types::Chat, Client, InputMessage, Update};

use crate::{bot::handlers::Handler, utils::messages::get_message};

#[derive(Clone)]
pub struct GetUserId;

#[async_trait::async_trait]
impl Handler for GetUserId {
    async fn react(&self, _: &Client, update: &Update) -> anyhow::Result<()> {
        let message = get_message(update);
        let Some(msg) = message else {
            return Ok(());
        };
        let Chat::User(user) = msg.chat() else {
            return Ok(());
        };
        let username = user.username().unwrap_or("Unknown username");
        let user_id = user.id();
        msg.reply(InputMessage::text(format!("{username}: {user_id}")).silent(true))
            .await?;
        Ok(())
    }
}
